/* $Id: main.c,v 1.1.1.1 2004/08/12 15:20:17 roman Exp $ */
/* written by Roman R. Stocsits, 2004 */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

struct SEQdata *SEQ;
struct FILEdata *inputF;
struct Factors factors;
long count;

int naSCORE[5][5]=
{
  {1000, 300, 300, 300, 300},  
  {300, 1000, 300, 300, 300},
  {300, 300, 1000, 300, 300},
  {300, 300, 300, 1000, 300},
  {300, 300, 300, 300, 300}
};

int gapOPEN= -1500;
int gapEXT= -300;

short start_it(int argc, char **argv);
short use_me_this_way(short ret);
void findORF();
void makePS(short id);
void infoFile();
void EditFile(void);
void help(short ret);
short decideFN(char FN[256], char CTN[8]);
short readGBF(char FN[256], char CTN[8], char *line, FILE *fp, short is_fp);
char *get_seq(FILE *fp, char *line, long len, short is_fp);
short readPears(char FN[256], char CTN[8], char *line, FILE *fp, short is_fp);
short write2SEQ1(char FN[256], char CTN[8], char seqname[256],
		 char *seq, long len, struct CDSdata* ORF,
		 struct CDSdata *exon);
void mergeJOIN();
int align();
void pretranslate();
void encode();
void output();
void check();
void check_list();
short help2(short ret);
short help3(short ret);
short help4(char versuch);
short help5(char used_orf[360]);
short help6(char read_file[360]);
short help7(short ret);
void overrule(char used_orf[360]);
void drueberkuebln();
/*--------------------------------------------------------------------------*/

int main(int argc, char **argv){

  int c;
  short machs_aus = 0;
  
  count=0;
  inputF=(struct FILEdata*)space(100*sizeof(struct FILEdata));
  SEQ=(struct SEQdata*)space(300*sizeof(struct SEQdata));

  machs_aus = start_it(argc, argv);

  free(inputF);
  findORF();
  makePS(1);
  infoFile();
  EditFile();
  if(machs_aus == 2){
    drueberkuebln();
    makePS(2);
  }
  if(machs_aus == 1) exit(99);
  mergeJOIN();
  pretranslate();
  encode();
  c = align();
  output(c);
  check();
  check_list();
  fprintf(stdout, "See 'cluster.ral' and 'info.ral' for information about profiles.\n");
  return(0);
}

/*--------------------------------------------------------------------------*/

short start_it(int argc, char **argv){

  int i, dir;
  long min_len=0;
  short is_tty, ok=0, a=0, machs_aus=0;
  char currCTN[8], dummy[500], used_orf[360], read_naSCORE[360], read_gapPEN[360];
  char *line;
  FILE *edit, *naSCORE_fp=NULL, *gapPEN_fp=NULL;
  
  factors.aa_orf1=1;
  factors.aa_orf2=1;
  factors.aa_orf3=1;
  factors.non_code=1;
  factors.eins_coding=1;
  factors.zwei_coding=1;
  factors.drei_coding=1;
  factors.gap_open=1;
  factors.gap_ext=1;
  factors.match=1;
  factors.mismatch=1;
   
  is_tty=isatty(0);
  strcpy(currCTN, "univ\0");
  edit=fopen("edit.ral", "w");
  fprintf(edit, " * minimum open reading frame length is set by program *\n\n");
  fclose(edit);
  
  if(argc == 1) help(1);
  for(i=1;i<argc;i++){
    dir = strlen(argv[i]);
    if(argv[i][dir-1] == '/'){
      fprintf(stdout, " *\nNo files specified. No alignment.\n *\n");
      remove("edit.ral");
      exit(31);
    }
  }
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      switch(argv[i][1]){
      case 'h': help(10);
      case 'l':
	if(argv[++i]){
	  if(argv[i][0]=='-') help3(55);
	  sscanf(argv[i], "%li\n", &min_len);
	  edit=fopen("edit.ral", "w");
	  fprintf(edit, "[ minimum open reading frame length:  %li ]\n\n", min_len);
	  fclose(edit);
	}
	else	    help2(58);
	break;
      case 'a':
	switch(argv[i][2]){
	case '1':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(55);
	    sscanf(argv[i], "%f", &factors.aa_orf1);
	    /* fprintf(stdout, "1. == %f\n", factors.aa_orf1); */
	  }
	  else	    help2(58);
	  break;
	case '2':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(56);
	    sscanf(argv[i], "%f", &factors.aa_orf2);
	    /* fprintf(stdout, "2. == %f\n", factors.aa_orf2); */
	  }
	  else	    help2(59);
	  break;
	case '3':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(57);
	    sscanf(argv[i], "%f", &factors.aa_orf3);
	   /*  fprintf(stdout, "3. == %f\n", factors.aa_orf3); */
	  }
	  else	    help2(60); 
	  break;
	default: help(11);
	}
	break;
      case 'n':
	switch(argv[i][2]){
	case '0':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(55);
	    sscanf(argv[i], "%f", &factors.non_code);
	   /*  fprintf(stdout, "non_code == %f\n", factors.non_code); */
	  }
	  else	    help2(58);
	  break;
	case '1':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(64);
	    sscanf(argv[i], "%f", &factors.eins_coding);
	    /* fprintf(stdout, "eins_coding == %f\n", factors.eins_coding); */
	  }
	  else	    help2(59);
	  break;
	case '2':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(65);
	    sscanf(argv[i], "%f", &factors.zwei_coding);
	    /* fprintf(stdout, "zwei_coding == %f\n", factors.zwei_coding); */
	  }
	  else	    help2(59);
	  break;
	case '3':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(66);
	    sscanf(argv[i], "%f", &factors.drei_coding);
	    /* fprintf(stdout, "drei_coding == %f\n", factors.drei_coding); */
	  }
	  else	    help2(59);
	  break;
	default: help(60);
	}
	break;
      case 'g':
	switch(argv[i][2]){
	case 'o':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(55);
	    sscanf(argv[i], "%f", &factors.gap_open);
	    /* fprintf(stdout, "gap_open == %f\n", factors.gap_open); */
	  }
	  else	    help2(58);
	  break;
	case 'x':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(64);
	    sscanf(argv[i], "%f", &factors.gap_ext);
	    /* fprintf(stdout, "gap_ext == %f\n", factors.gap_ext); */
	  }
	  else	    help2(59);
	  break;
	default: help(60);
	}
	break;
      case 'm':
	switch(argv[i][2]){
	case '0':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(55);
	    sscanf(argv[i], "%f", &factors.mismatch);
	    /* fprintf(stdout, "mismatch == %f\n", factors.mismatch); */
	  }
	  else	    help2(58);
	  break;
	case '1':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(64);
	    sscanf(argv[i], "%f", &factors.match);
	    /* fprintf(stdout, "match == %f\n", factors.match); */
	  }
	  else	    help2(59);
	  break;
	default: help(60);
	}
	break;

      case 'c':
	if(argv[++i]){
	  if(argv[i][0]=='-') help3(66);
	  sscanf(argv[i], "%s", &dummy[0]);
	  if((!strcmp(dummy, "univ")) || (!strcmp(dummy, "acet")) ||
	     (!strcmp(dummy, "ccyl")) || (!strcmp(dummy, "tepa")) ||
	     (!strcmp(dummy, "eupl")) || (!strcmp(dummy, "mlut")) ||
	     (!strcmp(dummy, "mysp")) || (!strcmp(dummy, "mitocan")) ||
	     (!strcmp(dummy, "mitovrt")) || (!strcmp(dummy, "mitoart")) ||
	     (!strcmp(dummy, "mitoech")) || (!strcmp(dummy, "mitomol")) ||
	     (!strcmp(dummy, "mitoasc")) || (!strcmp(dummy, "mitonem")) ||
	     (!strcmp(dummy, "mitopla")) || (!strcmp(dummy, "mitoyea")) ||
	     (!strcmp(dummy, "mitoeua")) || (!strcmp(dummy, "mitopro"))){
	    strcpy(currCTN, dummy);
	    if(!argv[i+1]){
	      if(argc > 3) help(5);
	      fprintf(stdout, " *\nNo input sequences. No alignment.\n *\n");
	      remove("edit.ral");
	      exit(4);
	    }
	  }
	  else help3(3);
	}
	else help3(2);
	break;
      case 'f':
	if(argv[++i]){
	  if(argv[i][0]=='-') help3(69);
	  strcpy(used_orf, argv[i]);
	  overrule(used_orf);
	  machs_aus = 2;
	}
	else help3(2);
	break;
      case 'e':
	machs_aus = 1;
	break;
	
      case 'S':
	switch(argv[i][2]){
	case 'f':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(69);
	    strcpy(read_naSCORE, argv[i]);
	    naSCORE_fp = fopen(read_naSCORE, "r");
	    for(i=0; i<5; i++){
	      line=get_line(naSCORE_fp);
	      if(!line)  help6(read_naSCORE);
	      sscanf(line, "%i %i %i %i %i", &naSCORE[i][0], &naSCORE[i][1], &naSCORE[i][2],
		     &naSCORE[i][3], &naSCORE[i][4]);
	      free(line);
	    }
	    fclose(naSCORE_fp);
	  }
	  break;
	case 'i':
	  fprintf(stdout, "   *\nEnter nucleotide match scores for the following pairs of nucleotides:\n");
	  fprintf(stdout, "A - A:  ");
	  if(!scanf("\n%i", &naSCORE[0][0])){
	    fprintf(stdout, "INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "A - U/T:  ");
	  if(!scanf("%i", &naSCORE[0][1])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "A - G:  ");
	  if(!scanf("%i", &naSCORE[0][2])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "A - C:  ");
	  if(!scanf("%i", &naSCORE[0][3])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "G - G:  ");
	  if(!scanf("%i", &naSCORE[2][2])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "G - U/T:  ");
	  if(!scanf("%i", &naSCORE[2][1])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "G - C:  ");
	  if(!scanf("%i", &naSCORE[2][3])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "C - C:  ");
	  if(!scanf("%i", &naSCORE[3][3])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "C - U/T:  ");
	  if(!scanf("%i", &naSCORE[3][1])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "U/T - U/T:  ");
	  if(!scanf("%i", &naSCORE[1][1])){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed.\nAborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "anything else:  ");
	  if(!scanf("%i", &naSCORE[4][4])){
	    fprintf(stdout, "INPUT ERROR in line before.\nOnly integers allowed. Aborting input of nucleotide match scores.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  break;   
	default: help(60);
	}
	break;
	
      case 'G':
	switch(argv[i][2]){
	case 'f':
	  if(argv[++i]){
	    if(argv[i][0]=='-') help3(69);
	    strcpy(read_gapPEN, argv[i]);
	    gapPEN_fp = fopen(read_gapPEN, "r");
	    line=get_line(gapPEN_fp);
	    if(!line)  help6(read_gapPEN);
	    sscanf(line, "%i %i", &gapOPEN, &gapEXT);
	    free(line);
	    fclose(gapPEN_fp);
	  }
	  break;
	case 'i':
	  fprintf(stdout, "   *\nEnter gap open penalty:  \n");
	  if(!scanf("\n%i", &gapOPEN)){
	    fprintf(stdout, "INPUT ERROR in line before.\nOnly integers allowed. Aborting input of gap penalties.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  fprintf(stdout, "Enter gap extension penalty:  ");
	  if(!scanf("%i", &gapEXT)){
	    fprintf(stdout, "  INPUT ERROR in line before.\nOnly integers allowed. Aborting input of gap penalties.\nUsing DEFAULT values...\n\n");
	    break;
	  }
	  break;
	default: help(60);
	}
	break;
      default: help4(argv[i][1]);
      }
      continue;
    }
    else {
      /* if(!argv[i]) help3(89); */
      strcpy(inputF[a].FN, argv[i]);
      strcpy(inputF[a].CTN, currCTN);
    }
    ok=decideFN(inputF[a].FN, inputF[a].CTN);
    a++;
  }
  if(!is_tty) {
    strcpy(inputF[a].CTN, currCTN);
    inputF[a].FN[0]='\0';
    ok=decideFN(inputF[a].FN, inputF[a].CTN);
  }
  if(!ok){
    fprintf(stdout, " *\nAt least two input sequences necessary. No alignment.\n *\n");
    remove("edit.ral");
    exit(10);
  }
  return(machs_aus);
}

/*--------------------------------------------------------------------------*/

void help(short ret){
  
  char *date;

  date=time_stamp();
  fprintf(stderr, "\n* * * * * * * * * codaln * * * * * * * * *\n");
  fprintf(stderr, "Multiple Nucleic Acid Sequence Alignments \n");
  fprintf(stderr, "Based on Genetic Information (Version 1.0)\n");
  fprintf(stderr, "           by Roman R. Stocsits\n");
  remove("edit.ral");
  if(ret == 10) use_me_this_way(ret);
  fprintf(stderr, "Type 'codaln -h' or see the man page for further information about usage.\n");
  fprintf(stderr, "current time: %s", date);
  fprintf(stderr, "Bye!\n");
  exit(0);
}

/*--------------------------------------------------------------------------*/
short help2(short ret){
  
  fprintf(stderr, " * \nNo value set for custom parameter choice.\n");
  fprintf(stderr, "Type codaln -h\nor see man page for assistance.\n *\n");
  remove("edit.ral");
  exit(ret);
}

/*--------------------------------------------------------------------------*/
short help3(short ret){
  
  fprintf(stderr, " * \nInput format error.\n");
  fprintf(stderr, "Type codaln -h\nor see man page for assistance.\n *\n");
  remove("edit.ral");
  exit(ret);
}

/*--------------------------------------------------------------------------*/
short help4(char versuch){
  
  fprintf(stderr, " * \nUnknown input option '-%c'.\n", versuch);
  fprintf(stderr, "Type codaln -h\nor see man page for assistance.\n *\n");
  remove("edit.ral");
  exit(77);
}
/*--------------------------------------------------------------------------*/
short help5(char used_orf[360]){
  
  fprintf(stderr, " * \nInput file '%s' seems to be corrupted.\n", used_orf);
  fprintf(stderr, "See the documentation for an example with correct format.\n *\n");
  remove("edit.ral");
  exit(69);
}

/*--------------------------------------------------------------------------*/
short help6(char read_file[360]){
  
  fprintf(stderr, " * \nInput file '%s' seems to be corrupted.\n", read_file);
  fprintf(stderr, "See the documentation for an example with correct format.\n *\n");
  remove("edit.ral");
  exit(69);
}
/*--------------------------------------------------------------------------*/
short help7(short ret){
  
  fprintf(stderr, " * \nSevere error while merging separate coding regions.\n");
  fprintf(stderr, "Is there a modified(!) 'edit.ral' input file with corrupted JOIN settings?\n *\n");
  remove("edit.ral");
  exit(ret);
}

/*--------------------------------------------------------------------------*/

short use_me_this_way(short ret){
  char *date;
  
  date=time_stamp();
  fprintf(stderr, "Usage: codaln [OPTIONS[PARAMS]] [FILES] [OPTIONS[PARAMS]] [FILES] ...\n");
  fprintf(stderr, "   FILES:   Path(s) and file name(s) of data files.\n");
  fprintf(stderr, "   OPTIONS: See man page for all possible options.\n");
  fprintf(stderr, "   PARAMS:  See man page for further descriptions.\n");
  fprintf(stderr, "Default codon table is universal genetic code.\n");
  fprintf(stderr, "Codon tables of the following organisms are also usable:\n");
  fprintf(stderr, "   Acetabularia, Candida cylindrica, Tetrahymena,\n"); 
  fprintf(stderr, "   Paramecium, Oxytrichia, Stylonychia, Glaucoma,\n");
  fprintf(stderr, "   Euplotes, Micrococcus luteus, Mycoplasma,\n");
  fprintf(stderr, "   Spiroplasma, canonical mitochondrial code,\n");
  fprintf(stderr, "   further all non-canonical mitochondrial codes for\n");
  fprintf(stderr, "     Arthropods, Echinoderms, Molluscs, Ascidians,\n");
  fprintf(stderr, "     Nematodes, Plathelminths, Yeasts, Euascomycetes,\n");
  fprintf(stderr, "     Vertebrates, and Protozoans.\n");
  fprintf(stderr, "See the man page for codon table instructions.\n");
  fprintf(stderr, "current time: %s", date);
  exit(ret);
}

/*--------------------------------------------------------------------------*/

short decideFN(char FN[256], char CTN[8]){

  FILE *fp;
  char *line;
  short ok=0, is_fp=0;
  
  if(FN[0]){
    fp=fopen(FN, "r");
    if(!fp){
      fprintf(stderr, " *\nCould not open file '%s'.\n *\n", FN);
      remove("edit.ral");
      exit(4);
    }
    else is_fp=1;
  }
  else{
    fp=NULL;
    is_fp=0;
  }
  line=get_line(fp);
  if(line[0]=='>') ok=readPears(FN, CTN, line, fp, is_fp);
  else {
    if((!strncmp(line, "[Entrez", 7))||
       (!strncmp(line, "LOCUS", 5))||
       (!strncmp(line, "ID", 2))||
       (!isalpha(line[0])))    ok=readGBF(FN, CTN, line, fp, is_fp);
    else  ok=readPears(FN, CTN, line, fp, is_fp);
  }
  return(ok);
}

/*---------------------------------------------------------------------------*/

char *get_seq(FILE *fp, char *line, long len, short is_fp){

  char *seq;
  long j, k=0, n;
  
  
  if((!strncmp(line,"ORIGIN", 6))||(!strncmp(line, "SQ", 2))){
    free(line);
    line=get_line(fp);
  }
  if(len==0){
    fprintf(stderr," *\nBad error! Failure of file reading.\n *\n");
    remove("edit.ral");
    exit(33);
  }
  seq=(char*)space((len+1)*sizeof(char));
  while(strncmp(line,"//",2)!=0){
    n=strlen(line);
    for (j=0;j<n;j++){
      if(isalpha(line[j])){
	seq[k]=toupper(line[j]);
	k++;
      }  
    }
    free(line);
    line=get_line(fp);
    continue;
  }
  seq[k]='\0'; 
  if(k!=len){
    fprintf(stderr," *\nBad error! Failure of file reading.\n *\n");
    remove("edit.ral");
    exit(4);
  }
  return(seq);
}

/*--------------------------------------------------------------------------*/

short readPears(char FN[256], char CTN[8], char *line, FILE *fp, short is_fp){

  char *seq, seqname[256], revname[256];
  long n, m=0, k=0, i, len; 
  short ok=0;
  int x, y;
  struct CDSdata *orf=NULL;
  struct CDSdata *exon=NULL;
  
  seq=NULL;
  orf=(struct CDSdata*)space(120*sizeof(struct CDSdata)); 
  exon=(struct CDSdata*)space(120*sizeof(struct CDSdata));
  for(i=0;i<120;i++){
    exon[i].start=exon[i].stop=orf[i].start=orf[i].stop=0;
    exon[i].join=0;
    exon[i].weight=0;
    orf[i].join=0;
    orf[i].weight=0;
    exon[i].AAseq=NULL;
    exon[i].joinedSeq=NULL;
    orf[i].AAseq=NULL;
    orf[i].joinedSeq=NULL;
  }
  seqname[0]='\0';
  while(line){
    if(!strncmp(line, ">", 1)){
      sscanf(line, "%*[>] %s", seqname);
      seq=NULL;
      k=0;
      m=0;

      /* free(line); */
      line=get_line(fp);
    }
    n=strlen(line);
    m=m+n;
    if(seq){
      seq=(char*)realloc(seq, (m+1)*sizeof(char));
    }
    else {
      seq=(char*)space((n+1)*sizeof(char));
    }
    for(i=0;i<n;i++){
      if(isalpha(line[i])){
	seq[k] = toupper(line[i]);
	k++;
      }
    }
    seq[k]='\0';
    /* free(line); */
    line = get_line(fp);
    if(line){
      if(!strncmp(line, ">", 1)){
	len=strlen(seq);
	ok=write2SEQ1(FN, CTN, seqname, seq, len, orf, exon);
	free(seq);
      }
    }
  }
  len=strlen(seq);
  if(!seqname[0]){
    x = strlen(FN);
    y=-1;
    while(x){
      x--;
      y++;
      if(FN[x] != '/')  revname[y] = FN[x];
      else break;
    }
    if(!x)     revname[y+1] = '\0';
    else  revname[y] = '\0';
    x = strlen(revname);
    y=0;
    while(x){
      x--;
      seqname[y] = revname[x];
      y++;
    }
    seqname[y] = '\0';
  }
  
  ok=write2SEQ1(FN, CTN, seqname, seq, len, orf, exon);
  free(seq);
  if(is_fp)  fclose(fp);
  return(ok);
}

/*--------------------------------------------------------------------------*/

short write2SEQ1(char FN[256], char CTN[8], char seqname[256],
		 char *seq, long len, struct CDSdata *ORF,
		 struct CDSdata *exon){

  short ok=0;
  
  SEQ[count].no=count+1;
  SEQ[count].len=len;
  strcpy(SEQ[count].FN, FN);
  SEQ[count].seq=(char*)space((len+1)*sizeof(char));
  strcpy(SEQ[count].seq, seq);
  SEQ[count+1].seq=NULL;
  SEQ[count].seqname=(char*)space(257*sizeof(char));
  strcpy(SEQ[count].seqname, seqname);
  strcpy(SEQ[count].CTN, CTN);
  SEQ[count].ORF=ORF;
  SEQ[count].exon=exon;
  count++;
  if(count>=2) ok=1;
  return(ok);
}

